#!/bin/sh
### BEGIN INIT INFO
# Provides:          omnomirc
# Required-Start:    $local_fs $network $named $time $syslog
# Required-Stop:     $local_fs $network $named $time $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Description:       OmnomIRC Bot
### END INIT INFO
 
####Config####
FOLDER="/bot"
RUNAS=bot
 
PIDFILE=/var/run/omnomirc.pid
CURIDFILE=/run/omnomirc_curid
 
####Script####
start() {
  if [ -f "$PIDFILE" ] && kill -0 $(cat "$PIDFILE"); then
    echo 'Service already running' >&2
    return 1
  fi
  echo 'Starting service…' >&2
  echo "0" > $CURIDFILE
  chmod 777 $CURIDFILE
  cd $FOLDER
  local CMD="./omnomirc.sh &> /dev/null & echo \$!"
  su -s /bin/bash -c "$CMD" $RUNAS > "$PIDFILE"
  echo 'Service started' >&2
}
 
stop() {
  if [ ! -f "$PIDFILE" ] || ! kill -0 $(cat "$PIDFILE"); then
    echo 'Service not running' >&2
    return 1
  fi
  echo 'Stopping service…' >&2
#  rm $CURIDFILE
  kill -3 $(cat "$PIDFILE")
  wait $(cat "$PIDFILE")
  rm -f "$PIDFILE"
  echo 'Service stopped' >&2
}
 
uninstall() {
  echo -n "Are you really sure you want to uninstall this service? That cannot be undone. [yes|No] "
  local SURE
  read SURE
  if [ "$SURE" = "yes" ]; then
    stop
    rm -f "$PIDFILE"
    echo "Notice: log file is not be removed: '$LOGFILE'" >&2
    update-rc.d -f omnomirc remove
    rm -fv "$0"
  fi
}
 
case "$1" in
  start)
    start
    ;;
  stop)
    stop
    ;;
  uninstall)
    uninstall
    ;;
  restart)
    stop
    start
    ;;
  *)
    echo "Usage: $0 {start|stop|restart|uninstall}"
esac
